summaryrefslogtreecommitdiffstats
path: root/cppcheck.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-19 02:57:58 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-19 02:57:58 +0000
commitbe1c7e50e1e8809ea56f2c9d472eccd8ffd73a97 (patch)
tree9754ff1ca740f6346cf8483ec915d4054bc5da2d /cppcheck.sh
parentInitial commit. (diff)
downloadnetdata-be1c7e50e1e8809ea56f2c9d472eccd8ffd73a97.tar.xz
netdata-be1c7e50e1e8809ea56f2c9d472eccd8ffd73a97.zip
Adding upstream version 1.44.3.upstream/1.44.3upstream
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'cppcheck.sh')
-rwxr-xr-xcppcheck.sh35
1 files changed, 35 insertions, 0 deletions
diff --git a/cppcheck.sh b/cppcheck.sh
new file mode 100755
index 00000000..ebbeeaf8
--- /dev/null
+++ b/cppcheck.sh
@@ -0,0 +1,35 @@
+#!/usr/bin/env bash
+
+# echo >>/tmp/cppcheck.log "cppcheck ${*}"
+
+# shellcheck disable=SC2230
+cppcheck=$(which cppcheck 2>/dev/null || command -v cppcheck 2>/dev/null)
+[ -z "${cppcheck}" ] && echo >&2 "install cppcheck." && exit 1
+
+processors=$(grep -c ^processor /proc/cpuinfo)
+[ $(( processors )) -lt 1 ] && processors=1
+
+base="$(dirname "${0}")"
+[ "${base}" = "." ] && base="${PWD}"
+
+cd "${base}" || exit 1
+
+[ ! -d "cppcheck-build" ] && mkdir "cppcheck-build"
+
+file="${1}"
+shift
+# shellcheck disable=SC2235
+([ "${file}" = "${base}" ] || [ -z "${file}" ]) && file="${base}"
+
+"${cppcheck}" \
+ -j ${processors} \
+ --cppcheck-build-dir="cppcheck-build" \
+ -I .. \
+ --force \
+ --enable=warning,performance,portability,information \
+ --library=gnu \
+ --library=posix \
+ --suppress="unusedFunction:*" \
+ --suppress="nullPointerRedundantCheck:*" \
+ --suppress="readdirCalled:*" \
+ "${file}" "${@}"